﻿' -----------------------------------------------------------------------------------------
' VB.NET用SMTPメール送信関数サンプルプログラム.
'
' 著作:日本システム開発株式会社.
'
' Copyright (C) 2009 Nihon System Developer Corp. All rights reserved.
' -----------------------------------------------------------------------------------------
Imports System.Windows.Forms

Public Class Account
    #Region "Sub OK_Button_Click : OKボタン."
        Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
            Try
                ' ----------------------------------------------------------
                ' ユーザー情報.
                ' ----------------------------------------------------------
                    Dim Str_MailAddress As String = Me.Txt_UserAddress.Text.Trim    ' E-Mailアドレス.
                    Dim Str_DispName As String = Me.Txt_UserName.Text.Trim          ' 表示名.

                    ' 差出人のユーザー情報を設定します.
                    ClsPub_Smtp.SetFromAddress(Str_MailAddress, Str_DispName)

                ' ----------------------------------------------------------
                ' サーバー情報.
                ' ----------------------------------------------------------
                    Dim ServerInfo As New NSDSmtp.MAIL_SMTP_Server_INFO
                    With ServerInfo
                        ' 送信サーバー名.
                        .Host = Me.Txt_SmtpServer.Text.Trim
                        ' ポート番号.
                        Dim Str_Port As String = Me.Txt_Port.Text.Trim
                        If IsNumeric(Str_Port) Then
                            .Port = Convert.ToInt32(Str_Port)
                        End If
                        ' タイムアウト.
                        Dim Str_TimeOut As String = Me.Txt_TimeOut.Text.Trim
                        If IsNumeric(Str_TimeOut) Then
                            .TimeOut = Convert.ToInt32(Str_TimeOut)
                        End If
                    End With
                    ClsPub_Smtp.SetServerInfo(ServerInfo)

                ' ----------------------------------------------------------
                ' メール サーバーへのログオン情報.
                ' ----------------------------------------------------------
                    Dim Str_AccountName As String = Me.Txt_AccountName.Text.Trim    ' アカウント名.
                    Dim Str_Password As String = Me.Txt_Password.Text.Trim          ' パスワード.
                    ClsPub_Smtp.SetAccountInfo(Str_AccountName, Str_Password)

                Me.DialogResult = System.Windows.Forms.DialogResult.OK
                Me.Close()
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub OK_Button_Click : キャンセルボタン."
        Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
            Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            Me.Close()
        End Sub
    #End Region

    #Region "Sub Account_Load : Loadイベント."
        Private Sub Account_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                ' ----------------------------------------------------------
                ' ユーザー情報.
                ' ----------------------------------------------------------
                    Dim Str_MailAddress As String = ""  ' E-Mailアドレス.
                    Dim Str_DispName As String = ""     ' 表示名.

                    ' 差出人のユーザー情報を取得します.
                    ClsPub_Smtp.GetFromAddress(Str_MailAddress, Str_DispName)

                    ' 名前にセットします.
                    Me.Txt_UserName.Text = Str_DispName
                    ' 電子メールアドレスにセットします.
                    Me.Txt_UserAddress.Text = Str_MailAddress

                ' ----------------------------------------------------------
                ' サーバー情報.
                ' ----------------------------------------------------------
                    Dim ServerInfo As New NSDSmtp.MAIL_SMTP_Server_INFO
                    If ClsPub_Smtp.GetServerInfo(ServerInfo) Then
                        ' 送信サーバー名.
                        If Not (ServerInfo.Host Is Nothing) Then
                            Me.Txt_SmtpServer.Text = ServerInfo.Host.Trim
                        End If
                        ' ポート番号.
                        Me.Txt_Port.Text = ServerInfo.Port
                        ' タイムアウト.
                        Me.Txt_TimeOut.Text = ServerInfo.TimeOut
                    End If

                ' ----------------------------------------------------------
                ' メール サーバーへのログオン情報.
                ' ----------------------------------------------------------
                    Dim Str_AccountName As String = ""
                    Dim Str_Password As String = ""
                    If ClsPub_Smtp.GetAccountInfo(Str_AccountName, Str_Password) Then
                        ' アカウント名.
                        Me.Txt_AccountName.Text = Str_AccountName
                        ' パスワード.
                        Me.Txt_Password.Text = Str_Password
                    End If

            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region
End Class
